package ch.dieseite.sqlite3.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.sql.Statement;


import ch.dieseite.sqlite3.wrapper.SmallSQLiteWrapper;

public class StatementImpl implements Statement
{
	private boolean debug = true; //provoziere exceptions was nicht implementiert ist
	
	
	private SmallSQLiteWrapper wrap;
	
	public StatementImpl(SmallSQLiteWrapper w)
	{
		wrap = w;
	}
	
	@Override
	public ResultSet executeQuery(String arg0) throws SQLException 
	{
		wrap.execSQL(arg0);
		ResultSetImpl rs = new ResultSetImpl(wrap.getRows(), wrap.getcolNames());
		return rs;
	}

	@Override
	public void close() throws SQLException {
		wrap = null;
	}
	
	@Override
	public int executeUpdate(String arg0) throws SQLException {
		wrap.execSQL(arg0);
		return 0;
	}
	
	//not implemented methods	
	
	@Override
	public boolean isWrapperFor(Class<?> arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}	

	@Override
	public <T> T unwrap(Class<T> arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public void addBatch(String arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void cancel() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void clearBatch() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void clearWarnings() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public boolean execute(String arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public boolean execute(String arg0, int arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public boolean execute(String arg0, int[] arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public boolean execute(String arg0, String[] arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public int[] executeBatch() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public int executeUpdate(String arg0, int arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int executeUpdate(String arg0, int[] arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int executeUpdate(String arg0, String[] arg1) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public Connection getConnection() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public int getFetchDirection() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int getFetchSize() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public ResultSet getGeneratedKeys() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public int getMaxFieldSize() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int getMaxRows() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public boolean getMoreResults() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public boolean getMoreResults(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public int getQueryTimeout() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public ResultSet getResultSet() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public int getResultSetConcurrency() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int getResultSetHoldability() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int getResultSetType() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public int getUpdateCount() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return 0;
	}

	@Override
	public SQLWarning getWarnings() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return null;
	}

	@Override
	public boolean isClosed() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public boolean isPoolable() throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		return false;
	}

	@Override
	public void setCursorName(String arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setEscapeProcessing(boolean arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setFetchDirection(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setFetchSize(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setMaxFieldSize(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setMaxRows(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setPoolable(boolean arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

	@Override
	public void setQueryTimeout(int arg0) throws SQLException {
		if (debug) throw new NoSuchMethodError("Method in StatementClass not Implemented");
		
	}

}
